unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ULoad, UCommon, Grids, ExtCtrls,UMyPoint,UList;

type
  TFormMain = class(TForm)
    StrGrid: TStringGrid;
    ButtonExact: TButton;
    Memo: TMemo;
    Image: TImage;
    ButtonGreed: TButton;
    Time: TTimer;
    ButtonClear: TButton;

    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ButtonExactClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimeTimer(Sender: TObject);
    procedure ButtonGreedClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;
  G:TGRaph;
  mincolor,n:integer;
  hosts:TPointList;
  CurTime:integer;
implementation
Const Colors : array[1..6] of TColor =(clGreen,clRed,clPurple,clBlue,clYellow,clAqua);
{$R *.dfm}
////////     
procedure WriteMas(AColors:TMas);
var i:integer;
    p:TMyPoint;
begin
 For i:=0 to N-1 do
  begin
   p:=hosts.GetPoint(i);
   p.draw(1,colors[AColors[i]]);
   Application.ProcessMessages;
  end;
end;
/////  ,       
function Nezavisit(G:TGraph;s:TSet):boolean;
var i,j:integer;
begin
 i:=0;
 result:=true;
 while (i<>n) and result do
  begin
   j:=0;
   Application.ProcessMessages;
   while (j<>i) and result do
    begin
     if (G[i,j]=1) and (i in s) and (j in s)
      then result:=false;
     inc(j);
     Application.ProcessMessages;
    end;
   inc(i);
  end;
end;

procedure Paint(All,b:TSEt;ColorMas:TMas;color:integer); forward;
/////////       
//  Aset  .
procedure Solve(All,Aset:TSEt;ColorMas:TMas;color:integer);
var i:integer;
begin
 if Aset<>[] then
  begin
   if Nezavisit(G,Aset) then       //      .
    Paint(All,Aset,ColorMas,color); //   ,  .
   for i:=0 to n do
    if i in Aset then
     begin
      Application.ProcessMessages;
      Aset:=Aset-[i];
      Solve(all,Aset,ColorMas,color);
      Aset:=Aset+[i];
     end;
  end;
end;
//   b  All  color     ColorMas
procedure Paint(All,b:TSEt;ColorMas:TMas;color:integer);
var i:integer;
begin
 for i:=0 to n-1 do
  if i in b then
   begin
    Application.ProcessMessages;
    All:=All-[i];
    ColorMas[i]:=color;
   end;
 if all<>[] then Solve(All,All,ColorMas,color+1)
  else                        //     ,   
   if color<mincolor then     //        
    begin                     //  .
     Application.ProcessMessages;
     mincolor:=color;
     writemas(ColorMas);
    end;
end;

//////     
procedure TFormMain.ButtonExactClick(Sender: TObject);
var
  i:integer;
  e:TMas; // ,       
  b:TSEt; //   
begin
 CurTime:=0;
 Caption:='  ...';
 Time.Enabled:=true;
 b:=[];
 for i:=0 to n-1 do
  begin
   b:=b+[i];
   Application.ProcessMessages;
   E[i]:=0;
  end;
 mincolor:=5;  //    5- 
 Solve(b,b,E,1); //  ,  
 Time.Enabled:=false;
 Memo.Lines.Add('  :  = '
                  +IntToStr(CurTime*10)+' .   = '
                  +IntTostr(mincolor)+#13+#10);
 Caption:='.';
end;
//////    " "
procedure TFormMain.ButtonGreedClick(Sender: TObject);
var cvet,i,maxcvet:integer;
    E:Tmas;
 //  , ,       color
 //    index
 function Nelzya(index,color:integer):boolean;
 var i:integer;
 begin
  result:=false;
  for i:=0 to index-1 do
   begin
    Application.ProcessMessages;
    result:=result or ((G[i,index]=1) and (E[i]=color));
   end;
 end;

Begin // Main-  
 CurTime:=0;
 Caption:='  ...';
 Time.Enabled:=true;
 maxcvet:=0;
 for i:=0 to n-1 do
  E[i]:=0;
 for i:=0 to n-1 do
  begin
   cvet:=1;
   Application.ProcessMessages;
   while Nelzya(i,cvet) do inc(cvet);
   E[i]:=cvet;
   if cvet>maxcvet then maxcvet:=cvet;
  end;
  writemas(e);
 Time.Enabled:=false;
 Memo.Lines.Add('  :  = '
                  +IntToStr(CurTime*10)+' .   = '
                  +IntTostr(maxcvet)+#13+#10);
 Caption:='.';
end;
//     
procedure TFormMain.FormCreate(Sender: TObject);
var i:integer;
j:integer;
begin
 for i:=0 to MaxN-1 do
  For j:=0 to MaxN-1 do
   G[i,j]:=0;
 Strgrid.cells[0,1]:='1';
 Strgrid.cells[1,0]:='1';
end;
//   
procedure TFormMain.TimeTimer(Sender: TObject);
begin
 inc(CurTime);
end;

/////      
procedure TFormMain.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var p,q:TMypoint;
 cur : TPoint;
 i,j:integer;
begin
 ButtonExact.Enabled:=true;
 ButtonGreed.Enabled:=true;
  if Button=mbLeft then
    begin
      cur := TControl(Sender).ScreenToClient(Mouse.CursorPos);
      strgrid.cells[0,strgrid.rowCount]:=inttostr(strgrid.rowCount);
      strgrid.cells[strgrid.rowCount,0]:=inttostr(strgrid.rowCount);
      if (hosts.Count>=strgrid.ColCount-1) then
        begin
          strgrid.ColCount:=strgrid.ColCount+1;
          strgrid.rowCount:=strgrid.rowCount+1;
          for i:=1 to  strgrid.rowCount do
            begin
              strgrid.cells[i,strgrid.rowCount]:='0';
              strgrid.cells[strgrid.rowCount,i]:='0';
            end;
        end;
      if not hosts.cross(cur.X,cur.y) then
      begin
        p:=TMypoint.create(cur.X,cur.y,canvas);
        p.draw(1);
        hosts.add(p);
        inc(n);
      end
      else
        begin
          i:=hosts.IndexPoint(cur.X,cur.y);
          p:=hosts[i];
          p.set_ch(false);
          p.draw(0);
          p.draw(1);
        end;
    end;
  if Button=mbRight then
    begin
      cur := TControl(Sender).ScreenToClient(Mouse.CursorPos);
      if hosts.cross(cur.X,cur.y) then
      begin
        i:=hosts.IndexPoint(cur.X,cur.y);
        p:=hosts[i];
        p.set_ch(true);
        p.draw(0);
        p.draw(2);
        if hosts.quant=2 then
          begin
            p.draw(0);
            p.draw(1);
            p.set_ch(false);
            j:=hosts.getchoosen;
            q:=hosts[j];
            q.draw(0);
            q.draw(1);
            q.set_ch(false);
            Canvas.MoveTo(p.gx,p.gy);
            Canvas.LineTo(q.gx,q.gy);
            strgrid.Cells[i+1,j+1]:='1';
            strgrid.Cells[j+1,i+1]:='1';
            G[i,j]:=1;
            G[j,i]:=1;
          end;
      end;
    end;
end;

procedure TFormMain.ButtonClearClick(Sender: TObject);
var i,j:integer;
begin
 for i:=0 to n-1 do
   for j:=0 to n-1 do
    G[i,j]:=0;
 n:=0;
 hosts.Destroy;
 hosts:=TPointList.Create;
 StrGrid.ColCount:=2;
 StrGrid.RowCount:=2;
 Image.Refresh;
end;

initialization
n:=0;
hosts:=TPointList.Create;
end.
